;
; Startup code for cc65 (ATARI version)
;
; Contributing authors:
;	Mark Keates
;	Freddy Offenga
;	Christian Groessler
;
; This must be the *first* file on the linker command line
;

	.export		_exit
	.import		_main
	.import		__CODE_LOAD__, __BSS_LOAD__
	.import		__BSS_RUN__, __BSS_SIZE__

;	.include	"header.s"

; ------------------------------------------------------------------------
; Define and export the ZP variables for the runtime

	.exportzp	sp, sreg, regsave


sp	= $32		; (2bytes) stack pointer
sreg	= $34		; (2bytes) secondary register/high 16 bit for longs
regsave = $36		; (4bytes) slot to save/restore (E)AX into
ptr1	= $3A		; (2bytes)
zpspace = $3C - sp	; Zero page space allocated

; ------------------------------------------------------------------------
; EXE header

	.segment "EXEHDR"
	.word	$FFFF
	.word	__CODE_LOAD__
	.word	__BSS_LOAD__ - 1
	.code
	.reloc

; ------------------------------------------------------------------------
; Actual code

	rts	; fix for SpartaDOS / OS/A+
		; they first call the entry point from AUTOSTRT and
		; then the load addess (this rts here).
		; We point AUTOSTRT directly after the rts.

; Real entry point:

; Save the zero page locations we need

	ldy	#zpspace-1
L1:	lda	sp,y
	sta	zpsave,y
	dey
	bpl	L1

; Clear the BSS data

	jsr	zerobss

; setup the stack

	tsx
	stx	spsave

	jsr	_main		; call the users code

; fall thru to exit...

_exit:

	ldx	spsave
	txs			; Restore stack pointer

; Copy back the zero page stuff

	ldy	#zpspace-1
L2:	lda	zpsave,y
	sta	sp,y
	dey
	bpl	L2

; Back to DOS

	rts

; *** end of main startup code

zerobss:
	lda	#<__BSS_RUN__
	sta	ptr1
	lda	#>__BSS_RUN__
	sta	ptr1+1
	lda	#0
	tay

; Clear full pages

@1:	ldx	#>__BSS_SIZE__
	beq	@3
@2:	sta	(ptr1),y
   	iny
   	bne	@2
	inc	ptr1+1
	dex
	bne	@2

; Clear remaining page (y is zero on entry)

@3:	ldx	#<__BSS_SIZE__
   	beq	@5
@4:	sta	(ptr1),y
   	iny
   	dex
   	bne	@4

; Done

@5:	rts


	.data

zpsave:	.res	zpspace

	.bss

spsave:		.res	1
appmsav:	.res	1
old_shflok:	.res	1
old_lmargin:	.res	1

	.segment "AUTOSTRT"
	.word	$02E0
	.word	$02E1
	.word	__CODE_LOAD__ + 1
